#!/usr/bin/python

#Path to binaries

#Full path to executable
simulator = '/home/grannas/forskning/shadow_prefetch/simplesim-3.0/sim-outorder'
# Full path to simulation executables
specbinpath = '/home/grannas/spec2000binaries/'
# Where you want to store the temporary pbs file
temppbs = 'sim-outorder.pbs'
# Where the data files to the spec benchmarks are
specdatapath = '/home/grannas/SPEC_2000_REDUCED/'

# Common configuration across benchmarks.
commonconfig = '-cache:dl1 dl1:32:64:4:l -cache:dl1lat 2 -cache:il1 il1:32:64:4:l -cache:il1lat 2 -cache:dl2 ul2:512:128:8:l -cache:dl2lat 7  -cache:il2 dl2 -cache:il2lat 7 -mem:width 8  -mem:lat 160 2 -fetch:mplat 15 -ruu:size 16 -lsq:size 8  -tlb:itlb itlb:1:4096:128:l -tlb:dtlb dtlb:1:4096:128:l  -bpred 2lev -bpred:bimod 4096 -bpred:2lev  1 1024 10 0   -bpred:comb 4096 -dram:block 128 -dram:page 8 -dram:comm 40 -dram:core 40 -dram:data 80 -dram:chan 1'

# Experiment name, used to generate plotfiles
experimentname = 'shadow-base'

# Parse out this statistic
grepname = 'sim_IPC'
#grepname = 'dram.accesses'
#grepname = 'ul2.prefetches_ok'
#grepname = 'ul2.misses'

# Configuration
# Format : (Name, Parameters)
configurations = [('None', '-prefetch none'), \
                  ('Sequential','-prefetch sequential'), \
                  ('Shadow','-prefetch sequential -shadow 1'), \
                  ('Perfect L2', '-perfect:l2 1')]



# Different benchmarks
# Format : (Name, binary, working dir, parameters)
benchmarks = [ ('gzip' , 'gzip00.peak.ev6', '164.gzip/input/', 'lgred.log 1'),\
('gcc' ,'gcc00.peak.ev6','176.gcc/input/','lgred.cp-decl.i -o lgred.cp-decl.s'),\
('crafty','crafty00.peak.ev6', '186.crafty/input/lgred/','< lgred.in'),\
('mcf','mcf00.peak.ev6', '181.mcf/input/', 'lgred.in'),\
('swim','swim00.peak.ev6', '171.swim/input/lgred/', '< swim.in'),\
('mgrid','mgrid00.peak.ev6','172.mgrid/input/lgred/', '< mgrid.in'),\
('equake','equake00.peak.ev6','183.equake/input/' ,'< lgred/lgred.in'),\
('applu','applu00.peak.ev6','173.applu/input/lgred', '< applu.in'),\
('vpr','vpr00.peak.ev6','175.vpr/input/', 'lgred.net small.arch.in tull1 tull2 -nodisp -place_only -init_t 5 -exit_t 0.005 -alpha_t 0.9412 -inner_num 2'),\
('ammp','ammp00.peak.ev6','188.ammp/','< ./input/lgred.in'),\
('mesa','mesa00.peak.ev6','177.mesa/input/','-frames 1 -meshfile lgred.in -ppmfile utfil'),\
('galgel','galgel00.peak.ev6','178.galgel/input/lgred/','< lgred.in'),\
('lucas','lucas00.peak.ev6','189.lucas/input/lgred/','< lgred.in'),\
('fma','fma3d00.peak.ev6','191.fma3d/input/lgred/',''),\
('parser','parser00.peak.ev6','197.parser/input', '2.1.dict -batch < lgred.in'),\
('eon','eon00.peak.ev6','252.eon/input/lgred', 'chair.control.kajiya chair.camera chair.surfaces chair.kajiya.ppm ppm pixels_out.kajiya'),\
('perlbmk','perlbmk00.peak.ev6','253.perlbmk/input/lgred','-I. -I./lib lgred.makerand.pl'),\
('gap','gap00.peak.ev6','254.gap/input/lgred','-l . -q -m 64M < lgred.in'),\
('bzip2' , 'bzip200.peak.ev6','256.bzip2/input','lgred.source 1'),\
('apsi' , 'apsi00.peak.ev6', '301.apsi/input/lgred',''),\
('wupwise' , 'wupwise00.peak.ev6', '168.wupwise/input/lgred',''),\
('twolf' , 'twolf00.peak.ev6', '300.twolf/input/','lgred/lgred'),\
('facerec','facerec00.peak.ev6','187.facerec/input/lgred',' < lgred.in'),\
('art','art00.peak.ev6','179.art/input/','-scanfile c756hel.in -trainfile1 a10.img -stride 5 -startx 134 -starty 220 -endx 184 -endy 240 -objects 1')\
]

# Ikke fungerende :
# Sixtrack : Manglende filer? Filstoerrelse er ihvertfall 0.
# Vortex: Korrupt fil?
#('sixtrack','sixtrack00.peak.ev6','200.sixtrack/input/lgred', '< inp.in'),\
#('vortex','vortex00.peak.ev6','255.vortex/input','lgred.raw'),\
