/*
 * Copyright (c) 2004, 2005
 * The Regents of The University of Michigan
 * All Rights Reserved
 *
 * This code is part of the M5 simulator, developed by Nathan Binkert,
 * Erik Hallnor, Steve Raasch, and Steve Reinhardt, with contributions
 * from Ron Dreslinski, Dave Greene, Lisa Hsu, Kevin Lim, Ali Saidi, 
 * and Andrew Schultz.
 *
 * Permission is granted to use, copy, create derivative works and
 * redistribute this software and such derivative works for any
 * purpose, so long as the copyright notice above, this grant of
 * permission, and the disclaimer below appear in all copies made; and
 * so long as the name of The University of Michigan is not used in
 * any advertising or publicity pertaining to the use or distribution
 * of this software without specific, written prior authorization.
 *
 * THIS SOFTWARE IS PROVIDED AS IS, WITHOUT REPRESENTATION FROM THE
 * UNIVERSITY OF MICHIGAN AS TO ITS FITNESS FOR ANY PURPOSE, AND
 * WITHOUT WARRANTY BY THE UNIVERSITY OF MICHIGAN OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE. THE REGENTS OF THE UNIVERSITY OF MICHIGAN SHALL NOT BE
 * LIABLE FOR ANY DAMAGES, INCLUDING DIRECT, SPECIAL, INDIRECT,
 * INCIDENTAL, OR CONSEQUENTIAL DAMAGES, WITH RESPECT TO ANY CLAIM
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OF THE SOFTWARE, EVEN
 * IF IT HAS BEEN OR IS HEREAFTER ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGES.
 */

#ifndef __CPU_STATIC_INST_IMPL_HH__
#define __CPU_STATIC_INST_IMPL_HH__

/** @todo: Make this file generated by isa_parser.py eventually. */

/**
 * Execute this instruction under the SimpleCPU model.
 */
virtual Fault execute(SimpleCPU *xc, Trace::InstRecord *traceData) const = 0;

/**
 * Execute this instruction under the FastCPU model.
 */
virtual Fault execute(FastCPU *xc, Trace::InstRecord *traceData) const = 0;

/**
 * Execute this instruction under the FullCPU model.
 */
virtual Fault execute(DynInst *xc, Trace::InstRecord *traceData) const = 0;

/**
 * Execute this instruction under the Alpha Full CPU model.
 */
virtual Fault execute(AlphaDynInst<AlphaSimpleImpl> *xc, 
                      Trace::InstRecord *traceData) const = 0;

#endif // __CPU_STATIC_INST_IMPL_HH__
