
import popen2
import re
import os
import sys

rootdir = os.getenv("DIPPROOT")
if rootdir == None:
  print "Envirionment variable DIPPROOT not set. Quitting..."
  sys.exit(-1)

successString = 'Simulation complete'
lostString = 'Sampler exit lost'
binary = rootdir+'/m5_1.1/m5/build/ALPHA_SE/m5.opt'
bmArg = "-EBENCHMARK="
cpuArg = "-ENP="
interconArg = "-EINTERCONNECT="
args = "-EPROTOCOL=stenstrom -ESTATSFILE=test_output.txt -ESIMULATETICKS=15000000 -EFASTFORWARDTICKS=0"
#mshrargs = "-EMSHRSL1D=32 -EMSHRL1TARGETS=4 -EMSHRSL2=4 -EMSHRL2TARGETS=4"
mshrargs = ""
configFile = rootdir+"/m5_1.1/m5/configs/CMP/run.py"

REPORTFILE = "testreport.txt"
report = open(REPORTFILE, 'w')

cpus = [2,4,8] #[2, 4, 8]
interconnects = ['butterfly'] #['myBus', 'crossbar', 'idealwdelay'] #['myBus'] #, 'pipeBus'] #, 'ideal', 'crossbar', 'idealwdelay']

#benchmarks = ['hello', 'gzip', 'vpr', 'gcc', 'mcf', 'crafty', 'parser', 'eon', 'perlbmk', 'gap', 'bzip', 'twolf', 'wupwise', 'swim', 'mgrid', 'applu', 'galgel', 'art', 'equake', 'facerec', 'ammp', 'lucas', 'fma3d', 'sixtrack' ,'apsi', 'mesa', 'vortex1']

benchmarks = ['Cholesky', 'FFT', 'LUContig', 'LUNoncontig', 'Radix', 'Barnes', 'FMM', 'OceanContig', 'OceanNoncontig', 'Raytrace', 'WaterNSquared', 'WaterSpatial']

correct_pattern = re.compile(successString)
lost_req_pattern = re.compile(lostString)
    
print
print "M5 Test Results:"
print
report.write("\nM5 Test Results:\n")
testnum = 1
correctCount = 0

for cpu in cpus:
    for interconnect in interconnects:
        output = "Doing tests with "+str(cpu)+" cpus and "+interconnect+" interconnect:"
        print output
        report.write("\n"+output+"\n")
        for benchmark in benchmarks:
            #print binary+" "+bmArg+benchmark+" "+args+" "+configFile
            res = popen2.popen4("nice "+binary+" "+cpuArg+str(cpu)+" "+bmArg+benchmark+" "+interconArg+interconnect+" "+args+" "+mshrargs+" "+configFile)
            
            out = ""
            for line in res[0]:
                out += line
            
            correct = correct_pattern.search(out)
            lostReq = lost_req_pattern.search(out)
            
            if correct and (not lostReq):
                output = (str(testnum)+": "+benchmark).ljust(40)+"Test passed!".rjust(20)
                print output
                
                report.write(output+"\n")
                report.flush()
                
                correctCount = correctCount + 1
            else:
                output = (str(testnum)+": "+benchmark).ljust(40)+"Test failed!".rjust(20)
               
                print output
                
                report.write(output+"\n")
                report.flush()
                
                file = open(benchmark+str(cpu)+interconnect+".output", "w");
                file.write("Program output\n\n")
                file.write(out)
                file.close()
            testnum = testnum + 1
        print

print
output = ""
if correctCount == (len(benchmarks)*len(cpus)*len(interconnects)):
    output = "All tests completed successfully!"
else:
    output = "One or more tests failed..."
print output
print
report.write("\n"+output+"\n\n")

report.flush()
report.close()
