
import database_constants

create_table_benchmark = """CREATE TABLE """+database_constants.BENCHMARK_TABLE_NAME+"""(
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  name VARCHAR
);"""

create_table_configuration = """CREATE TABLE """+database_constants.CONFIGURATION_TABLE_NAME+"""(
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  cpu_count INTEGER,
  coherence_protocol VARCHAR,
  interconnect VARCHAR,
  L1_data_size VARCHAR,
  L1_instruction_size VARCHAR,
  L2_size VARCHAR
);"""

create_table_result = """ CREATE TABLE """+database_constants.RESULT_TABLE_NAME+"""(
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  configuration_id INTEGER,
  benchmark_id INTEGER,
  host_instruction_rate DOUBLE,
  host_simulation_time INTEGER,
  host_tick_rate DOUBLE,
  simulated_ticks INTEGER
);"""

create_table_memory_result = """CREATE TABLE """+database_constants.MEMORY_TABLE_NAME+"""(
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  result_id INTEGER
);"""

create_table_bus_result = """CREATE TABLE """+database_constants.BUS_TABLE_NAME+"""(
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  result_id INTEGER,
  data_idle_fraction DOUBLE,
  address_idle_fraction DOUBLE,
  data_use_cycles INTEGER
);"""

create_table_interconnect_result = """CREATE TABLE """+database_constants.INTERCONNECT_TABLE_NAME+"""(
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  result_id INTEGER,
  avgArbCyclesPerReq INTEGER,
  avgArbQueueCyclesPerReq INTEGER,
  avgTransCyclesPerReq INTEGER,
  avgTransQueueCyclesPerReq INTEGER,
  avgTotalDelayCyclesPerReq INTEGER,
  requests INTEGER,
  nullRequests INTEGER,
  duplicateRequests INTEGER,
  numClearBlocked INTEGER,
  numSetBlocked INTEGER
);"""

create_table_memory_bus_result = """CREATE TABLE """+database_constants.MEMORY_BUS_TABLE_NAME+"""(
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  result_id INTEGER,
  lineUseCycles INTEGER,
  address_idle_fraction DOUBLE
);"""

create_table_shared_L2_cache_result = """CREATE TABLE """+database_constants.L2_SHARED_TABLE_NAME+"""(
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  result_id INTEGER,
  overall_miss_rate DOUBLE
);"""

create_table_cpu_core_result = """CREATE TABLE """+database_constants.CPU_CORE_TABLE_NAME+"""(
  cpu_id INTEGER,
  result_id INTEGER,
  ipc DOUBLE,
  simulated_cycles INTEGER,
  PRIMARY KEY(cpu_id, result_id)
);"""

create_table_private_L2_cache_result = """CREATE TABLE """+database_constants.L2_PRIVATE_TABLE_NAME+"""(
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  cpu_core_result_id INTEGER,
  result_id INTEGER,
  overall_miss_rate DOUBLE
);"""

create_table_L1_data_cache_result = """CREATE TABLE """+database_constants.L1D_TABLE_NAME+"""(
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  cpu_core_result_id INTEGER,
  result_id INTEGER,
  overall_miss_rate DOUBLE,
  cc_read_invalid INTEGER,
  cc_write_invalid INTEGER,
  cc_write_owned INTEGER,
  cc_write_shared INTEGER
);"""

create_table_L1_instruction_cache_result = """CREATE TABLE """+database_constants.L1I_TABLE_NAME+"""(
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  cpu_core_result_id INTEGER,
  result_id INTEGER,
  overall_miss_rate DOUBLE
);"""

branch_predictor_result = """CREATE TABLE """+database_constants.BRANCH_PRED_TABLE_NAME+"""(
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  cpu_core_result_id INTEGER,
  result_id INTEGER,
  accuracy DOUBLE
);"""

create_table_queries = [create_table_benchmark,
                        create_table_configuration,
                        create_table_result,
                        create_table_memory_result,
                        create_table_interconnect_result,
                        create_table_bus_result,
                        create_table_memory_bus_result,
                        create_table_shared_L2_cache_result,
                        create_table_cpu_core_result,
                        create_table_private_L2_cache_result,
                        create_table_L1_data_cache_result,
                        create_table_L1_instruction_cache_result,
                        branch_predictor_result]




