#!/usr/bin/python

import pbsconfig
import database
import database_constants
import process_results

# create database
resultdb = database.Database()
resultdb.create_database()

# Make file-not-found list
notFound = open("filesNotFound.txt", "w")

# create result processing object
pr = process_results.Process_results(resultdb)


for benchmark in pbsconfig.benchmarks:
  pr.add_benchmark(benchmark)

for np in pbsconfig.number_of_cpus:
  for protocol in pbsconfig.protocols:
    for interconnect in pbsconfig.interconnects:
        pr.add_configuration(np, protocol, interconnect)

# add results
file_counter = 0
missed_files = 0
for benchmark in pbsconfig.benchmarks:
  for np in pbsconfig.number_of_cpus:
    for protocol in pbsconfig.protocols:
        for interconnect in pbsconfig.interconnects:
            resID = pbsconfig.get_unique_id(np, benchmark, protocol, interconnect)
            resultfile = None
            
            try:
                resultfile = open(resID+'/'+resID+'.txt')
            except IOError:
                print "WARNING (createresultdb.py):\tCould not find file "+resID+'/'+resID+'.txt'
                notFound.write(resID+'.txt\n')
                missed_files = missed_files + 1
          
            if resultfile != None:
                print "Processing experiment "+resID+ " ..."
                
                pr.find_patterns(resultfile, np)
                
                pr.process_results(benchmark, np, protocol, interconnect)
                
                file_counter = file_counter + 1
      
print 'Parsed '+str(file_counter)+' out of '+str(file_counter+missed_files)+' files and added the results to the database file '+resultdb.database_file_name

notFound.flush()
notFound.close()
