
import sys

HEADER = """
\\begin{table}[tp]
\t\\centering
\t\t\\begin{tabular}{|l|l|c|c|c|c|}
\t\t\t\\hline
\t\t\t\\textbf{Configuration} & \\textbf{Benchmark}  & \\textbf{Bus} & \\textbf{Butterfly} & \\textbf{Crossbar} & \\textbf{Ideal} \\\\
\t\t\t\\hline
"""

FOOTER = """
\t\t\\end{tabular}
\t\t\\caption{Splash Benchmarks where M5 Flaws were Observed}
\t\t\\label{tab:splashBugTable}
\\end{table}
"""

res = {}

keys = ['myBus', 'butterfly', 'crossbar', 'idealwdelay']

var = sys.stdin.readlines()
for line in var:
    st = line.split('/')
    st2 = st[0].split('_')
    np = int(st2[1])
    bm = st2[2].strip()
    ic = st2[4].strip()

    if np not in res:
        res[np] = {}

    if bm not in res[np]:
        res[np][bm] = {}
        for k in keys:
            res[np][bm][k] = False

    if ic in keys:
        res[np][bm][ic] = True


OUTFILE = "splashBugTable.tex"

out = open(OUTFILE, 'w')
out.write(HEADER)

procs = res.keys()
procs.sort()

for proc in procs:
    bms = res[proc].keys()
    bms.sort()

    first = True
    for bm in bms:

        if first:
            out.write("\t\t\t\\multirow{"+str(len(bms))+"}{*}{"+str(proc)+" CPUs} & ")
            first = False
        else:
            out.write("\t\t\t & ")
        out.write(bm+" & ")

        for k in keys:
                        
            if res[proc][bm][k]:
                out.write(" X ")
            else:
                out.write(" - ")

            if k == 'idealwdelay':
                out.write(" \\\\\n")
            else:
                out.write("&")
    out.write("\t\t\t\\hline\n")
        

#for benchmark in benchmarks:

 #   out.write("\t\t\t"+benchmark+" & ")

 #   for cpu in cpus[0:len(cpus)-1]:
 #       out.write(getValue(data[cpu][benchmark])+" & ")
 #   out.write(getValue(data[cpus[len(cpus)-1]][benchmark])+" \\\\\n")
    
 #   out.write("\t\t\t\\hline\n")

out.write(FOOTER)
out.close()
