import Splash2insts

def getValue(val):
    if val >= 1000000:
        if (val/1000000.0) != (val/1000000):
            return str(val/1000000.0)+" million"
        return str(val/1000000)+" million"
    return str(val/1000)+" thousand"
    

HEADER = """
\\begin{table}
\t\\centering
\t\t\\begin{tabular}{|l|r|r|r|}
\t\t\t\\hline
\t\t\t\\textbf{Benchmark} & \\textbf{2 CPUs} & \\textbf{4 CPUs} & \\textbf{8 CPUs} \\\\
\t\t\t\\hline
"""

FOOTER = """
\t\t\\end{tabular}
\t\t\\caption{Number of Instructions Simulated with SPLASH-2 Benchmarks}
\t\t\\label{tab:splashSimInsts}
\\end{table}
"""

OUTFILE = "simInstsSplash.tex"

out = open(OUTFILE, 'w')
out.write(HEADER)

data = Splash2insts.instructions

cpus = data.keys()
cpus.sort()
benchmarks = data[cpus[0]].keys()
benchmarks.sort()

for benchmark in benchmarks:

    out.write("\t\t\t"+benchmark+" & ")

    for cpu in cpus[0:len(cpus)-1]:
        out.write(getValue(data[cpu][benchmark])+" & ")
    out.write(getValue(data[cpus[len(cpus)-1]][benchmark])+" \\\\\n")
    
    out.write("\t\t\t\\hline\n")

out.write(FOOTER)
out.close()
