
import workloads

#\begin{table}
  #\centering
    #\begin{tabular*}{0.86\textwidth}{@{\extracolsep{\fill}} | >{\raggedright}b{0.35\textwidth} | >{\raggedright}b{0.45\textwidth} |}
      #\hline
      #\textbf{Parameter} & \textbf{Value} \tabularnewline
      #\hline
      #Level 1 Data Cache & 32 KB 8-way set associative\linebreak
                           #64KB blocks\linebreak
                           #LRU replacement policy\linebreak
                           #Write-Back\linebreak
                           #3 cycles latency \linebreak
                           #1 bank \linebreak
                           #4 MSHRs (Miss Status Holding Registers)\tabularnewline
      #\hline
      #Level 1 Instruction Cache & 32 KB 8-way set associative\linebreak
                                  #64KB blocks\linebreak
                                  #LRU replacement policy\linebreak
                                  #Write-Back\linebreak
                                  #1 cycle latency \linebreak
                                  #1 bank \linebreak
                                  #4 MSHRs\tabularnewline
      #\hline
      #Level 2 Unified Shared Cache & 4 MB 8-way set associative\linebreak
                                     #64KB blocks\linebreak
                                     #LRU replacement policy\linebreak
                                     #Write-Back\linebreak
                                     #14 cycles latency \linebreak
                                     #4 banks \linebreak
                                     #8 MSHRs per bank\tabularnewline
      #\hline
      #Main memory & 200 cycles access time\linebreak
                    #8 byte wide, 1 GHz DDR memory bus\tabularnewline
      #\hline
    #\end{tabular*}
  #\caption{Baseline memory system parameters}
  #\label{tab:memSpecification}
#\end{table}

HEADER = "\\begin{table}\n\
\t\\centering\n\
\t\t\\begin{tabular*}{0.91\\textwidth}{@{\\extracolsep{\\fill}} | >{\\raggedright}b{0.20\\textwidth} | >{\\raggedright}b{0.65\\textwidth} |}\n\
\t\t\t\\hline\n\
\t\t\t\\textbf{Workload ID} & \\textbf{SPEC Benchmarks} \\tabularnewline\n\
\t\t\t\\hline\n"

TAIL = "\\end{table}\n"

for cpu_count in workloads.workloads:
    outfile = open("workloads_"+str(cpu_count)+"cpus.tex", 'w')
    
    outfile.write(HEADER)
    
    bid = 1
    for wlKey in workloads.workloads[cpu_count]:
        
        benchmarks, fw = workloads.workloads[cpu_count][wlKey]
        
        outfile.write("\t\t\t"+str(bid)+" & ")
        
        for i in range(len(benchmarks)):
            if i != len(benchmarks)-1:
                outfile.write(benchmarks[i]+", ")
            else:
                outfile.write(benchmarks[i])
        
        outfile.write("\\tabularnewline\n")
        outfile.write("\t\t\t\\hline\n")
        bid = bid + 1

    outfile.write("\t\t\\end{tabular*}\n")
    outfile.write("\t\\caption{Randomly Generated Multiprogram Workloads for "+str(cpu_count)+" CPUs}\n")
    outfile.write("\t\\label{mpWorkloads"+str(cpu_count)+"cpus}\n")
        
    outfile.write(TAIL)
    outfile.flush()
    outfile.close()