
CREATE TABLE benchmark(
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  name VARCHAR
);

CREATE TABLE configuration(
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  cpu_count INTEGER,
  L1_data_size VARCHAR,
  L1_instruction_size VARCHAR,
  L2_size VARCHAR
);

CREATE TABLE result(
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  configuration_id INTEGER,
  benchmark_id INTEGER,
  host_instruction_rate DOUBLE,
  host_simulation_time INTEGER,
  host_tick_rate DOUBLE,
  simulated_instructions INTEGER
);

CREATE TABLE memory_result(
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  result_id INTEGER
);

CREATE TABLE shared_bus_result(
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  result_id INTEGER,
  data_idle_fraction DOUBLE,
  address_idle_fraction DOUBLE
);

CREATE TABLE memory_bus_result(
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  result_id INTEGER,
  data_idle_fraction DOUBLE,
  address_idle_fraction DOUBLE
);

CREATE TABLE shared_L2_cache_result(
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  result_id INTEGER,
  overall_miss_rate DOUBLE
);

CREATE TABLE cpu_core_result(
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  result_id INTEGER,
  ipc DOUBLE,
  simulated_cycles INTEGER
);

CREATE TABLE private_L2_cache_result(
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  cpu_core_result_id INTEGER,
  overall_miss_rate DOUBLE
);

CREATE TABLE L1_data_cache_result(
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  cpu_core_result_id INTEGER,
  overall_miss_rate DOUBLE
);

CREATE TABLE L1_instruction_cache_result(
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  cpu_core_result_id INTEGER,
  overall_miss_rate DOUBLE
);

CREATE TABLE branch_predictor_result(
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  cpu_core_result_id INTEGER,
  accuracy DOUBLE
);





