

import pbsconfig

np = 8

results = {}

for benchmark in pbsconfig.benchmarks:
  for protocol in pbsconfig.protocols:
    for interconnect in pbsconfig.interconnects:
      resID = pbsconfig.get_unique_id(np, benchmark, protocol, interconnect)
      resultfile = None
            
      resultfile = open(resID+'/interconnectSendProfile.txt')

      misses = 0
      lastTick = 0
      for line in resultfile.readlines()[2:]:
          vals = line.split(';')
          sampleTick = int(vals[0])
          totalMisses = int(vals[4])
          misses += totalMisses
          lastTick = sampleTick
          
      if benchmark not in results:
          results[benchmark] = {}

      if interconnect not in results[benchmark]:
          results[benchmark][interconnect] = {}

      results[benchmark][interconnect] = misses


sortedKeys = results.keys()
sortedKeys.sort()

print ("NP="+str(np)).ljust(20),
for ic in pbsconfig.interconnects:
  print ic.rjust(20),
print

for key in sortedKeys:
  thisDict = results[key]
  print (str(key)+': ').ljust(20),
  for ic in pbsconfig.interconnects:
    if ic in thisDict:
      print (str(thisDict[ic])).rjust(20),
    else:
      print (str(-5.0)).rjust(20),
  print

